## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
## Fully Extended CustomEventManager v1
## By Impaler, based on original CustomEventManager by dsplaisted

from CvPythonExtensions import *
import CvUtil
import CvEventManager
import sys
import OpenTech

#INSERT IMPORTS


ot = OpenTech.OpenTech()	
gc = CyGlobalContext()
#INSERT DEFINES


#################### INITIALIZER ###########################
class CvCustomEventManager(CvEventManager.CvEventManager):
	def __init__(self):
		# initialize base class
		self.parent = CvEventManager.CvEventManager
		self.parent.__init__(self)
		#INSERT INITIALIZERS
		
		
#################### EVENT STARTERS ######################
	def handleEvent(self, argsList):
		'EventMgr entry point'
		self.parent.handleEvent(self, argsList);
		#INSERT MODS
		
		
###################### EVENT APPLY ######################	
	def beginEvent(self, context, argsList=-1):
		'Begin Event'
		self.parent.beginEvent(self, context, argsList=-1);
		#INSERT MODS
	def applyEvent(self, argsList):
		'Apply the effects of an event'
		self.parent.applyEvent(self, argsList);
		#INSERT MODS
	def reportEvent(self, entry, context, argsList):
		'Report an Event to Events.log'
		self.parent.reportEvent(self, entry, context, argsList);
		#INSERT MODS
		
		
#################### ON EVENTS ######################		
	def onKbdEvent(self, argsList):
		'keypress handler - return 1 if the event was consumed'
		self.parent.onKbdEvent(self, argsList);
		#INSERT MODS
	def onInit(self, argsList):
		'Called when Civ starts up'
		self.parent.onInit(self, argsList);
		#INSERT MODS
	def onUpdate(self, argsList):
		'Called every frame'
		self.parent.onUpdate(self, argsList);
		#INSERT MODS
	def onWindowActivation(self, argsList):
		'Called when the game window activates or deactivates'
		self.parent.onWindowActivation(self, argsList);
		#INSERT MODS
	def onUnInit(self, argsList):
		'Called when Civ shuts down'
		self.parent.onUnInit(self, argsList);
		#INSERT MODS
	def onPreSave(self, argsList):
		'called before a game is actually saved'
		self.parent.onPreSave(self, argsList);
		#INSERT MODS
	def onSaveGame(self, argsList):
		'return the string to be saved - Must be a string'
		self.parent.onSaveGame(self, argsList);
		#INSERT MODS
	def onLoadGame(self, argsList):
		self.parent.onLoadGame(self, argsList);
		#INSERT MODS
	def onGameStart(self, argsList):
		'Called at the start of the game'
		self.parent.onGameStart(self, argsList);
		#INSERT MODS		
	def onGameEnd(self, argsList):
		'Called at the End of the game'
		self.parent.onGameEnd(self, argsList);
		#INSERT MODS		
	def onBeginGameTurn(self, argsList):
		'Called at the beginning of the end of each turn'
		self.parent.onBeginGameTurn(self, argsList);
		
		#INSERT MODS
	def onEndGameTurn(self, argsList):
		'Called at the end of the end of each turn'
		self.parent.onEndGameTurn(self, argsList);
		
		#INSERT MODS
	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		self.parent.onBeginPlayerTurn(self, argsList);
		ot.onBeginPlayerTurn(argsList)
		#INSERT MODS
	def onEndPlayerTurn(self, argsList):
		'Called at the end of a players turn'
		self.parent.onEndPlayerTurn(self, argsList);
		ot.onEndPlayerTurn(argsList)
		#INSERT MODS
	def onEndTurnReady(self, argsList):
		'??? Before end turn processing ???'
		self.parent.onEndTurnReady(self, argsList);
		#INSERT MODS
	def onFirstContact(self, argsList):
		'Firs Contact with another Empire'
		self.parent.onFirstContact(self, argsList);
		#INSERT MODS
	def onCombatResult(self, argsList):
		'Combat Result'
		self.parent.onCombatResult(self, argsList);
		#INSERT MODS
	def onCombatLogCalc(self, argsList):
		'Combat Result'
		self.parent.onCombatLogCalc(self, argsList);
		#INSERT MODS
	def onCombatLogHit(self, argsList):
		'Combat Message'
		self.parent.onCombatLogHit(self, argsList);
		#INSERT MODS
	def onImprovementBuilt(self, argsList):
		'Improvement Built'
		self.parent.onImprovementBuilt(self, argsList);
		#INSERT MODS
	def onRouteBuilt(self, argsList):
		'Route Built'
		self.parent.onRouteBuilt(self, argsList);
		#INSERT MODS
	def onPlotRevealed(self, argsList):
		'Plot Revealed'
		self.parent.onPlotRevealed(self, argsList);
		#INSERT MODS
	def onBuildingBuilt(self, argsList):
		'Building Completed'
		self.parent.onBuildingBuilt(self, argsList);
		#INSERT MODS
	def onProjectBuilt(self, argsList):
		'Project Completed'
		self.parent.onProjectBuilt(self, argsList);
		#INSERT MODS
	def onUnitMove(self, argsList):
		'unit move'
		self.parent.onUnitMove(self, argsList);
		
		#INSERT MODS
	def onUnitSetXY(self, argsList):
		'units xy coords set manually'
		self.parent.onUnitSetXY(self, argsList);
		#INSERT MODS
	def onUnitCreated(self, argsList):
		'Unit Completed'
		self.parent.onUnitCreated(self, argsList);
		#INSERT MODS
	def onUnitBuilt(self, argsList):
		'Unit Completed'
		self.parent.onUnitBuilt(self, argsList);
		#INSERT MODS
	def onUnitKilled(self, argsList):
		'Unit Killed'
		self.parent.onUnitKilled(self, argsList);
		#INSERT MODS
	def onUnitLost(self, argsList):
		'Unit Lost'
		self.parent.onUnitLost(self, argsList);
		#INSERT MODS
	def onUnitPromoted(self, argsList):
		'Unit Promoted'
		self.parent.onUnitPromoted(self, argsList);
		#INSERT MODS
	def onUnitSelected(self, argsList):
		'Unit Selected'
		self.parent.onUnitSelected(self, argsList);
		#INSERT MODS
	def onUnitRename(self, argsList):
		'Unit is renamed'
		self.parent.onUnitRename(self, argsList);
		#INSERT MODS
	def onGoodyReceived(self, argsList):
		'Goody received'
		self.parent.onGoodyReceived(self, argsList);
		#INSERT MODS
	def onGreatPersonBorn(self, argsList):
		'Unit Promoted'
		self.parent.onGreatPersonBorn(self, argsList);
		#INSERT MODS
	def onTechAcquired(self, argsList):
		'Tech Acquired'
		self.parent.onTechAcquired(self, argsList);
		#INSERT MODS
	def onTechSelected(self, argsList):
		'Tech Selected'
		self.parent.onTechSelected(self, argsList);
		ot.onTechSelected(argsList)
		
	def onReligionFounded(self, argsList):
		'Religion Founded'
		self.parent.onReligionFounded(self, argsList);
		#INSERT MODS
	def onReligionSpread(self, argsList):
		'Religion Has Spread to a City'
		self.parent.onReligionSpread(self, argsList);
		#INSERT MODS
	def onGoldenAge(self, argsList):
		'Begining of Golden Age'
		self.parent.onGoldenAge(self, argsList);
		#INSERT MODS
	def onEndGoldenAge(self, argsList):
		'End of a Golden Age'
		self.parent.onEndGoldenAge(self, argsList);
		#INSERT MODS
	def onChangeWar(self, argsList):
		'War Status Changes'
		self.parent.onChangeWar(self, argsList);
		#INSERT MODS
	def onChat(self, argsList):
		'Chat Message Event'
		self.parent.onChat(self, argsList);
		#INSERT MODS
	def onSetPlayerAlive(self, argsList):
		'Set Player Alive Event'
		self.parent.onSetPlayerAlive(self, argsList);
		#INSERT MODS
	def onCityBuilt(self, argsList):
		'City Built'
		self.parent.onCityBuilt(self, argsList);
		#INSERT MODS
	def onCityRazed(self, argsList):
		'City Razed'
		self.parent.onCityRazed(self, argsList);
		#INSERT MODS
	def onCityAcquired(self, argsList):
		'City Acquired'
		self.parent.onCityAcquired(self, argsList);
		#INSERT MODS
	def onCityLost(self, argsList):
		'City Lost'
		self.parent.onCityLost(self, argsList);
		#INSERT MODS
	def onCultureExpansion(self, argsList):
		'City Culture Expansion'
		self.parent.onCultureExpansion(self, argsList);
		#INSERT MODS
	def onCityGrowth(self, argsList):
		'City Population Growth'
		self.parent.onCityGrowth(self, argsList);
		#INSERT MODS
	def onCityDoTurn(self, argsList):
		'City Production'
		self.parent.onCityDoTurn(self, argsList);
		#INSERT MODS
	def onCityBuildingUnit(self, argsList):
		'City begins building a unit'
		self.parent.onCityBuildingUnit(self, argsList);
		#INSERT MODS
	def onCityBuildingBuilding(self, argsList):
		'City begins building a Building'
		self.parent.onCityBuildingBuilding(self, argsList);
		#INSERT MODS
	def onCityRename(self, argsList):
		'City is renamed'
		self.parent.onCityRename(self, argsList);
		 #INSERT MODS   
	def onVictory(self, argsList):
		'End of game Victory'
		self.parent.onVictory(self, argsList);
		#INSERT MODS
	def onGameUpdate(self, argsList):
		'sample generic event, called on each game turn slice'
		self.parent.onGameUpdate(self, argsList);
		#INSERT MODS
	def onMouseEvent(self, argsList):
		'mouse handler - returns 1 if the event was consumed'
		self.parent.onMouseEvent(self, argsList);
		#INSERT MODS
		
#################### NEW ON EVENT ######################



############### NEW TRIGGERED EVENTS ###################



######################## END ###########################
