## Sid Meier's Civilization 4
## Copyright Firaxis Games 2005
## OpenTech by Naf 


from CvPythonExtensions import *
import CvUtil
import PyHelpers
import Popup as PyPopup

# globals
gc = CyGlobalContext()
PyInfo = PyHelpers.PyInfo
PyPlayer = PyHelpers.PyPlayer

class OpenTech:

	def __init__(self):
                self.TechBuilding = gc.getInfoTypeForString("BUILDING_ACADEMY_EXCHANGE")

	def onTechSelected(self, argsList):
		'Tech Selected'
		iTechType, iPlayer = argsList
		
		player = gc.getPlayer(iPlayer)
		cutOut = False
	
		for iTeam in range(gc.getMAX_TEAMS()):
			oTeam = gc.getTeam(iTeam)
			eTeam = gc.getTeam(player.getTeam())
			listTech = []
			if cutOut != True:
				if oTeam.isHasTech(iTechType) and eTeam.isOpenBorders(iTechType) == True and player.isResearchingTech(iTechType):	
					for i in range(player.getNumCities()):
						player.getCity(i).setNumRealBuilding(self.TechBuilding, 1)
					cutOut = True
				else:	
					for i in range(player.getNumCities()):
						player.getCity(i).setNumRealBuilding(self.TechBuilding, 0)
	
	
	def onBeginPlayerTurn(self, argsList):
		'Called at the beginning of a players turn'
		iGameTurn, iPlayer = argsList
		player = gc.getPlayer(iPlayer)
		cutOut = False
	
		for iTeam in range(gc.getMAX_TEAMS()):
			oTeam = gc.getTeam(iTeam)
			eTeam = gc.getTeam(player.getTeam())
			for iLoopTech in range(gc.getNumTechInfos()):
				listTech = []
				if cutOut != True:
					if oTeam.isHasTech(iLoopTech) and eTeam.isOpenBorders(iTeam) == True and player.isResearchingTech(iLoopTech):	
						for i in range(player.getNumCities()):
							player.getCity(i).setNumRealBuilding(self.TechBuilding, 1)
							cutOut = True
					else:	
						for i in range(player.getNumCities()):
							player.getCity(i).setNumRealBuilding(self.TechBuilding, 0)
				
	def onEndPlayerTurn(self, argsList):
		'Called at the end of the beginning of a players turn'
		iGameTurn, iPlayer = argsList
		player = gc.getPlayer(iPlayer)
		cutOut = False
	
		for iTeam in range(gc.getMAX_TEAMS()):
			oTeam = gc.getTeam(iTeam)
			eTeam = gc.getTeam(player.getTeam())
			for iLoopTech in range(gc.getNumTechInfos()):
				listTech = []
				if cutOut != True:
					if oTeam.isHasTech(iLoopTech) and eTeam.isOpenBorders(iTeam) == True and player.isResearchingTech(iLoopTech):	
						for i in range(player.getNumCities()):
							player.getCity(i).setNumRealBuilding(self.TechBuilding, 1)
							cutOut = True
					else:	
						for i in range(player.getNumCities()):
							player.getCity(i).setNumRealBuilding(self.TechBuilding, 0)
			
				
				
